package consumer;

import org.apache.kafka.clients.producer.Partitioner;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;
import pojo.JsonCsvData;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Service
public class CsvFileReader {

    @Autowired
    @Qualifier("kafkaTemplate")
    KafkaTemplate<String,String> kafkaTemplate;

    @Autowired
    @Qualifier("outputTopicForProcessing")
    String outputTopic;

    public void csvFileReader(String path,Date starTime) throws InterruptedException, IOException {
        while(!Thread.interrupted() ) {
            System.out.println(outputTopic);
            Thread.sleep(15000);
            File directory = new File(path);
            File[] lFiles = directory.listFiles();

            //let prepare the pattern and compile it before hand to save time.
            String regex = "([0-9]+),([0-9]+),([0-9]+),([0-9]+.[0-9]+)";
            Pattern p = Pattern.compile(regex);
            Matcher m = p.matcher(""); //default Matcher
            int messageCount = 0;

            if (lFiles != null) {
                for (File file : lFiles) {
                    if (file.isFile()) {
                        String fileName = file.getName();
                        if ( !fileName.contains("_processed")) {
                            try (BufferedReader br = new BufferedReader(new FileReader(path + "\\" + "household.csv")))
                            {
                                String sCurrentLine;
                                int count = 0;
                                while ((sCurrentLine = br.readLine()) != null) {
                                    count++;
                                    if (count != 1) {
                                        JsonCsvData jsonData = validator(sCurrentLine,m);
                                        if (jsonData != null);
                                            //System.out.println(jsonData);
                                            kafkaTemplate.send(outputTopic, jsonData.getKey(),jsonData.getValue());
                                        messageCount++;
                                    }
                                }
                                System.out.println(messageCount);
                            }

                            file.renameTo(new File(file.getPath() + "_processed"));
                        }
                    }
                }
            }
        }

    }


    //TODO To use better data converter, though fields are very small so over engineering isn't required.
    public JsonCsvData validator(String line, Matcher m)
    {
        m.reset(line);
        if(m.matches())
        {
            Long time = Long.parseLong(m.group(3))*1000;
            return new JsonCsvData(time.toString(),"{\"house_id\":"+m.group(1)+",\"household_id\":"+m.group(2)+",\"timestamp\":"+time+",\"value\":"+m.group(4)+"}");
            //return "cosmos,house_id="+m.group(1)+",household_id="+m.group(2)+" value="+m.group(4)+" "+(Long.parseLong(m.group(3))*1000);
        }
        else
        return null;
    }
}
