package util;

import org.slf4j.LoggerFactory;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

/***
 * It is going to read the target property file and convert it into properties object.
 */
public class KafkaProperties {

    private Properties properties;

    private static final org.slf4j.Logger LOG = LoggerFactory.getLogger(KafkaProperties.class);

    public Properties getProperties() {
        return properties;
    }

    /***
     *
     * @param configurationPath : path of property file to read.
     */
    public KafkaProperties(String configurationPath) {
        properties = loadConsumerProperties(configurationPath);
    }

    //TODO needs to implement a property checker for null values and wrong formatted files
    /***
     *
     * @return the property object
     */
    private Properties loadConsumerProperties(String configurationPath) {
        Properties props=new Properties();
        try(InputStream reader = new FileInputStream(configurationPath))
        {
            props.load(reader);
        } catch (IOException e) {
            LOG.error("property file [ " +configurationPath+ " ] doesn't  found or corrupted");
            throw new TerminalException(e,"property file [ " +configurationPath+ " ] doesn't  found or corrupted");
        }

        return props;
    }

}
