package util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

/***
 * this class is responsible to creating consumer object, that will be used to read from topics.
 */
public class PropertyToMapConverter {

    private static final Logger LOG = LoggerFactory.getLogger(PropertyToMapConverter.class);

    private Map<String,Object> KafkaProducerProperties;

    public Map<String,Object> getKafkaProducerProperties() {
        return KafkaProducerProperties;
    }

    public PropertyToMapConverter(Properties propFromFile)
    {
        this.KafkaProducerProperties = getProperties(propFromFile);
    }

    private Map<String,Object> getProperties(Properties propFomFile) {
        Map<String,Object> myProperties = new HashMap();
        propFomFile.stringPropertyNames().forEach(x->{
            if(propFomFile.getProperty(x) != null)
            {
                myProperties.put(x,propFomFile.getProperty(x));
            }
            else
            LOG.warn("property key "+ propFomFile.getProperty(x) + "is not valid!!");
        });
        return myProperties;
    }


}
