import org.apache.spark.sql.Dataset;
import org.apache.spark.sql.SparkSession;
import org.apache.spark.sql.types.DataTypes;
import org.apache.spark.sql.types.Metadata;
import org.apache.spark.sql.types.StructField;
import org.apache.spark.sql.types.StructType;
import org.codehaus.jackson.util.DefaultPrettyPrinter;
import scala.xml.Null;

import javax.xml.validation.Schema;
import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

import static org.apache.spark.sql.functions.*;

public class SparkDataFrameMain {

    public static void main(String[] args) throws ParseException {

        SparkSession spark = SparkSession
                .builder()
                .appName("Java Spark SQL data sources example")
                .config("spark.master", "local[6]")
                .getOrCreate();

        File directory = new File("D:\\projects\\aws-capacitor\\basicsparkingestion\\dataset");
        File[] lFiles;
        lFiles = directory.listFiles();

        SimpleDateFormat st = new SimpleDateFormat("dd-MM-yyyy_H");

        if (lFiles != null) {
            List<Date> dates = new ArrayList<>();
            Map<Date,String> folderDateMap = new HashMap<>();
            for (File lFile : lFiles) {
                if(lFile.isDirectory()) {
                    Date dt = st.parse(lFile.getName());
                    dates.add(dt);
                    folderDateMap.put(dt, lFile.getName());
                }
            }
            dates.sort(Date::compareTo);

//            int countf = 0;

            for (int i = 22; i<24; i++) {
                int j =0;
                Dataset aggregateDataset = null;
                Dataset aggregateDatasetForAlert2 = null;
                Date dateToFolder = dates.get(i);
                while (j<721) {
                    Dataset currentDataset = null;
                    //String folderForDataframe = folderDateMap.get(dateToFolder);
                    String currentFolderName = folderDateMap.get(dateToFolder);


                    if(currentFolderName != null) {
                        if(aggregateDataset == null)
                        {
                            currentDataset = spark
                                    .read()
                                    .json("D:\\projects\\aws-capacitor\\basicsparkingestion\\dataset\\" + currentFolderName)
                                    .persist();

                            aggregateDataset= currentDataset;
                            aggregateDataset.persist();
                            aggregateDatasetForAlert2 = currentDataset;
                            aggregateDatasetForAlert2.persist();
//                            System.out.println(currentFolderName);
//                            countf ++;
                        }
                        else {
                            currentDataset = spark
                                    .read()
                                    .json("D:\\projects\\aws-capacitor\\basicsparkingestion\\dataset\\" + currentFolderName)
                                    .persist();
                        }

                        aggregateDataset
                                .groupBy("house_id","household_id")
                                .agg(avg("value").as("avgvalue"),stddev("value").as("stdvalue"))
                                .coalesce(30)
                                .createOrReplaceTempView("history");

                        aggregateDatasetForAlert2
                                .groupBy("house_id")
                                .agg(avg("value").as("avgvalue"),stddev("value").as("stdvalue"))
                                .coalesce(10)
                                .createOrReplaceTempView("historyforalert2");

                        currentDataset
                                .distinct()
                                .groupBy("house_id","household_id")
                                .agg(avg("value").as("sumvalue"))
                                .coalesce(30)
                                .createOrReplaceTempView("now");

                        spark.sql("select a.house_id,a.household_id, IF((a.sumvalue - b.avgvalue)>b.stdvalue,1,0) " +
                                "as alert from now as a, history as b " +
                                "where (a.house_id = b.house_id) and (a.household_id = b.household_id)")
                                .withColumn("date",lit(currentFolderName))
                                .orderBy("house_id","household_id")
                                .coalesce(1)
                                .write()
                                .json("D:\\projects\\aws-capacitor\\basicsparkingestion\\resultset1\\"+currentFolderName);

                        spark.sql("select a.house_id,a.household_id, IF((a.sumvalue - b.avgvalue)>b.stdvalue,1,0) " +
                                "as alert from now as a, historyforalert2 as b " +
                                "where a.house_id = b.house_id")
                                .withColumn("date",lit(currentFolderName))
                                .orderBy("house_id","household_id")
                                .coalesce(1)
                                .write()
                                .json("D:\\projects\\aws-capacitor\\basicsparkingestion\\resultset2\\"+currentFolderName);

//                        aggregateDataset = aggregateDataset.union(currentDataset).persist();
                        aggregateDatasetForAlert2 = aggregateDatasetForAlert2.union(currentDataset).persist();
                    }
                        j = j + 24;
                        dateToFolder.setTime(dateToFolder.getTime() + (24 * 60 * 60 * 1000));
                }
//                System.out.println("**********************");

            }
//            System.out.println(countf);
        }
    }
}
